#pragma once

#include "backend/instr.hpp"
#include "backend/program.hpp"
#include "common/regarch.hpp"

namespace backend {

namespace riscv {

class BruteAllocator {
    Function* func;
    std::vector<int> reg_alloc;
    std::map<int, int> stack_offset;
    std::map<int, Reg> reg_binding;
    void allocreg(BasicBlock* bb);
    void allocreginstr(Instr* instr, BasicBlock* bb);
    Reg allocregreg(Reg reg, bool read, std::set<Reg> live_in, BasicBlock* bb);
    void StoreToStack(int temp_reg_id, BasicBlock* bb);
    void LoadFromStack(int temp_reg_id, BasicBlock* bb);
public:
    BruteAllocator(Function* _func);
};

} // namespace riscv

} // namespace backend