#include <iostream>
#include <fstream>
#include <exception>

using namespace std;


std::istream& gen_input(int argc, char* argv[]) {
  for(int i = 1; i < argc; ) {
    auto const arg = std::string_view{argv[i]};
    if (arg == "-o") {
      i += 2;
    } else if (!arg.empty() && arg.front() == '-') {
      ++i;
    } else {
      static std::ifstream ifs;
      ifs.open(argv[i]);
      return ifs;
    }
  }
  return std::cin;
}

void delete_space(string &s) 
 {
    if (s.empty()) 
    {
        return ;
    }
    s.erase(0,s.find_first_not_of(" "));
    s.erase(s.find_last_not_of(" ") + 1);
}

void modify_input_file(std::istream& inp, std::ostream& modified_inp) {
    std::string line;
    int current_line = 1;

    while (std::getline(inp, line)) {
        //std::cout << "dd" <<  line << "dd" << std::endl;
        delete_space(line);
        if (line == "starttime();" || line == "stoptime();") {
            modified_inp << line.substr(0, line.size() - 3) << "(" << current_line << ");" << std::endl;
        } else {
            modified_inp << line << std::endl;
        }
        current_line++;
    }
}

int main(int argc, char* argv[]) {

    return 0;
}