#include "middleend/copy_propagation.hpp"

namespace middleend {

void CopyPropagation::run() {
    for (auto bb : *func_->get_basic_blocks()) {
        for (auto & inst : *bb->get_instructions()) {
            if (auto assign = dynamic_cast<ir::instruction::Assign *>(inst)) {
                auto dst = assign->getdst();
                auto src = assign->getsrc();
                if (!copy_map.count(src->get_index())) {
                    copy_map[dst->get_index()] = src;
                }
                else{
                    copy_map[dst->get_index()] = copy_map[src->get_index()];
                }
            }
            // if (auto li = dynamic_cast<ir::instruction::LoadImm4 *>(inst)) {
            //     auto dst = li->getdst();
            //     auto imm = li->getimm();
            //     temp2const_map[dst->get_index()] = imm.iv;
            //     if(!const2temp_map.count(imm.iv)){
            //         const2temp_map[imm.iv] = dst;
            //     }
            // }
        }
    }
    for (auto bb : *func_->get_basic_blocks()) {
        for (auto & inst : *bb->get_instructions()) {
            if(auto phi = dynamic_cast<ir::instruction::Phi *>(inst))
            {
                continue;
            }
            else {
                for(auto & use : *inst->get_src()){
                    if(use == nullptr)continue;
                    if(copy_map.count(use->get_index())){
                        use = copy_map[use->get_index()];
                    }
                    // if(temp2const_map.count(use->get_index())){
                    //     use = const2temp_map[temp2const_map[use->get_index()]];
                    // }
                }
            }
        }
    }
}

}