#pragma once

#include "middleend/ir.hpp"
#include "middleend/cfg.hpp"

namespace middleend {

class CopyPropagation {
private:
    ir::Function *func_;
    std::unordered_map<int, Temp*> copy_map; // temp index -> temp
    std::unordered_map<int, int> temp2const_map; // temp index -> const
    std::unordered_map<int, Temp*> const2temp_map; // const -> temp
    void run();
public:
    CopyPropagation(ir::Function *func) : func_(func) { run(); }
};

}