#include "middleend/optmizer.hpp"
#include "middleend/cfg.hpp"
#include "middleend/mem2reg.hpp"
#include "middleend/constant_propagation.hpp"
#include "middleend/remove_useless_inst.hpp"
#include "middleend/copy_propagation.hpp"
#include "middleend/function_inline.hpp"

namespace middleend {

Optimizer::Optimizer(ir::Module *module) {
    for (auto func : *module->get_functions()) {
        optimize_func(func);
    }
    // FunctionInline fi(module);
    for (auto func : *module->get_functions()) {
        CFG *cfg = new CFG(func);
        ConstantPropagation cp(func);
        RemoveUselessInst ru(func);
        cfg->rebuild();
        ConstantPropagation cp2(func);
        RemoveUselessInst ru2(func);
        cfg->rebuild();
    }
}

void Optimizer::optimize_func(ir::Function *func) {
    CFG *cfg = new CFG(func);
    Mem2Reg mem2reg(cfg);
    ConstantPropagation cp(func);
    RemoveUselessInst ru(func);
    cfg->rebuild();
    ConstantPropagation cp2(func);
    RemoveUselessInst ru2(func);
    cfg->rebuild();
}

} // namespace middleend