#pragma once

#include "middleend/ir.hpp"

namespace middleend {

class ReversePostOrder {
private:
    std::unordered_set<int> visit;
    void dfs_reverse_postorder(int cur, CFG * cfg) {
        visit.insert(cur);
        for (auto nxt : *cfg->get_bb_succ(cur)) {
            if (!visit.count(nxt)) {
                dfs_reverse_postorder(nxt, cfg);
            }
        }
        order.push_back(cur);
    }
public:
    std::vector<int> order;
    ReversePostOrder(CFG *cfg) {
        if (cfg->get_bb_list()->size() == 0) return;
        dfs_reverse_postorder(cfg->get_bb_list()->front(), cfg);
        std::reverse(order.begin(), order.end());
    }
};

} // namespace middleend